"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = applyExtras;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("./utils");

var _asyncTypeaheadWidget = require("./components/asyncTypeaheadWidget");

var _asyncTypeaheadWidget2 = _interopRequireDefault(_asyncTypeaheadWidget);

var _asyncTableWidget = require("./components/asyncTableWidget");

var _asyncTableWidget2 = _interopRequireDefault(_asyncTableWidget);

var _asyncComplexTypeaheadWidget = require("./components/asyncComplexTypeaheadWidget");

var _asyncComplexTypeaheadWidget2 = _interopRequireDefault(_asyncComplexTypeaheadWidget);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function applyExtras(FormComponent) {
  var FormWithExtras = function (_Component) {
    _inherits(FormWithExtras, _Component);

    function FormWithExtras(props) {
      _classCallCheck(this, FormWithExtras);

      return _possibleConstructorReturn(this, (FormWithExtras.__proto__ || Object.getPrototypeOf(FormWithExtras)).call(this, props));
    }

    _createClass(FormWithExtras, [{
      key: "render",
      value: function render() {
        var configs = Object.assign({}, this.props);

        delete configs.schema;
        delete configs.uiSchema;

        var widgets = this.createWidgetObject(this.props.widgetData);

        return _react2.default.createElement(FormComponent, _extends({}, configs, {
          schema: this.props.schema,
          uiSchema: this.props.uiSchema,
          widgets: widgets
        }));
      }
    }, {
      key: "createWidgetObject",
      value: function createWidgetObject(widgetData) {
        var widgets = {
          asyncTypeaheadWidget: this.widgetObjFactory(_asyncTypeaheadWidget2.default, widgetData.asyncTypeaheadWidgetData),
          asyncTableWidget: this.widgetObjFactory(_asyncTableWidget2.default, widgetData.asyncTableWidgetData),
          asyncComplexTypeaheadWidget: this.widgetObjFactory(_asyncComplexTypeaheadWidget2.default, widgetData.asyncComplexTypeaheadWidgetData)
        };

        return widgets;
      }
    }, {
      key: "widgetObjFactory",
      value: function widgetObjFactory(WidgetClass, widgetData) {

        function CustomWidget(props) {
          return _react2.default.createElement(WidgetClass, _extends({}, props, {
            widgetData: widgetData
          }));
        }

        return CustomWidget;
      }
    }]);

    return FormWithExtras;
  }(_react.Component);

  return FormWithExtras;
}